<template>
  <div class="app-container">
    <!-- 配方模板表 -->
    <div ref="template" class="template">
      <p class="recipeTemplate" />
      <div class="operation">
        <el-button class="success" @click="form_add">新生成</el-button>
        <el-button class="export" style="float: right;margin-right: 80px;" @click="handleHistoryRecord">历史记录</el-button>
        <el-button class="export" style="float: right;margin-right: 10px;" @click="handleMaterialPlan">撒料计划</el-button>
        <el-button class="export" style="float: right;margin-right: 10px;" @click="handlePremixedPlan">预混计划</el-button>
        <el-button class="export" style="float: right;margin-right: 10px;" @click="handleShedFormula">栏舍配方</el-button>
        <el-button class="export" style="float: right;margin-right: 10px;" @click="handleRecipeemplate">配方模板</el-button>
      </div>

      <div class="search">
        <el-date-picker v-model="table.getdataListParm.parammaps.mydate" type="date" placeholder="选择日期" style="width: 150px;" format="yyyy-MM-dd" value-format="yyyy-MM-dd" :clearable="false" @change="changeDate" />
        <el-button class="el-icon-arrow-left elIconArrowLeft" @click="handleBefore" />
        <el-button class="el-icon-arrow-right elIconArrowRight" @click="handleNext" />
        <el-select v-model="table.getdataListParm.parammaps.lpplantype" filterable placeholder="计划类型" class="filter-item" clearable style="width: 120px;" @change="changePlanType">
          <el-option v-for="(item,index) in planTypeList" :key="item.value" :label="item.lable" :value="item.value" />
        </el-select>
        <el-select v-model="table.getdataListParm.parammaps.times" filterable placeholder="班次" class="filter-item" style="width: 120px;" clearable @change="changeFrequency">
          <el-option v-for="(item,index) in frequencyList" :key="index" :label="item.name" :value="item.id" />
        </el-select>
        <el-select v-model="table.getdataListParm.parammaps.enable" filterable placeholder="打印类型" class="filter-item" clearable style="width: 120px;">
          <el-option v-for="(item,index) in printingTypeList" :key="item.value" :label="item.label" :value="item.value" />
        </el-select>
        <el-select v-model="table.getdataListParm.parammaps.enable" filterable placeholder="计划维度" class="filter-item" style="width: 120px;" clearable>
          <el-option v-for="(item,index) in planningDimensionList" :key="item.value" :label="item.label" :value="item.value" />
        </el-select>
        <el-select v-model="table.getdataListParm.parammaps.enable" filterable placeholder="导出类型" class="filter-item" style="width: 120px;" clearable>
          <el-option v-for="(item,index) in exportTypeList" :key="item.value" :label="item.label" :value="item.value" />
        </el-select>
        <el-button class="export" @click="form_export">导出</el-button>
      </div>
      <!-- 日执行计划 -->
      <div class="table">
        <el-table :key="table.tableKey" v-loading="table.listLoading" element-loading-text="给我一点时间" :data="table.list" border fit highlight-current-row style="width: 98%;" :row-style="rowStyle" :cell-style="cellStyle" class="elTable table-fixed" @row-click="tableRowClick">
          <el-table-column label="序号" align="center" type="index" width="50px" />
          <el-table-column label="计划名称" min-width="130px" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.projname }}</span>
            </template>
          </el-table-column>
          <el-table-column label="计划类型" prop="weight" min-width="130px" align="center" :formatter="lpplantype" />
          <el-table-column label="TMR编号" min-width="130px" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.tmrtname }}</span>
            </template>
          </el-table-column>
          <el-table-column label="驾驶员" min-width="130px" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.driver }}</span>
            </template>
          </el-table-column>
          <el-table-column label="已执行" min-width="130px" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.havebutton }}</span>
            </template>
          </el-table-column>
          <el-table-column label="班次" min-width="180px" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.times }}</span>
            </template>
          </el-table-column>
          <el-table-column label="理论量" min-width="180px" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.lweight }}</span>
            </template>
          </el-table-column>
          <el-table-column label="时间" min-width="180px" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.plantime }}</span>
            </template>
          </el-table-column>
          <el-table-column label="发料位" min-width="180px" align="left">
            <template slot-scope="scope">
              <span>{{ scope.row.barnames }}</span>
            </template>
          </el-table-column>
        </el-table>
      </div>
    </div>

    <!-- 计划内容操作 -->
    <div class="content">
      <div class="table2">
        <p class="contentOperation" />
        <div class="content-table">
          <el-table :key="table2.tableKey" v-loading="table2.listLoading" element-loading-text="给我一点时间" :data="table2.list" fit highlight-current-row style="width: 100%;" height="450" :row-style="rowStyle" :cell-style="cellStyle" class="elTable table-fixed">
            <el-table-column label="操作序号" min-width="130px" align="center">
              <template slot-scope="scope">
                <span>{{ scope.row.sort }}</span>
              </template>
            </el-table-column>
            <el-table-column label="饲料名称" prop="fname" min-width="130px" align="center">
              <template slot-scope="scope">
                <span>{{ scope.row.fname }}</span>
              </template>
            </el-table-column>
            <el-table-column label="设计重量（KG）" prop="weight" min-width="130px" align="center">
              <template slot-scope="scope">
                <span>{{ scope.row.weight }}</span>
              </template>
            </el-table-column>
          </el-table>
        </div>

      </div>
      <div class="table3">
        <p class="stallRetails" />
        <!-- <div class="stallRetails">
          <p>栏舍内容<br>栏舍详情 </p>
        </div> -->
        <div class="content-table">
          <el-table :key="table3.tableKey" v-loading="table3.listLoading" element-loading-text="给我一点时间" :data="table3.list" height="450" fit highlight-current-row style="width: 100%;" :row-style="rowStyle" :cell-style="cellStyle" class="elTable table-fixed">
            <el-table-column label=" 操作序号" min-width="130px" align="center">
              <template slot-scope="scope">
                <span>{{ scope.row.sort }}</span>
              </template>
            </el-table-column>
            <el-table-column label="栏舍编号" min-width="130px" align="center">
              <template slot-scope="scope">
                <span>{{ scope.row.fname }}</span>
              </template>
            </el-table-column>
            <el-table-column v-if="table3.getdataListParm.parammaps.lpplantype == 3" label="转投栏舍" min-width="130px" align="center">
              <template slot-scope="scope">
                <span>{{ scope.row.useinbar }}</span>
              </template>
            </el-table-column>
            <el-table-column v-else label="设计重量（KG）" min-width="130px" align="center">
              <template slot-scope="scope">
                <span>{{ scope.row.weight }}</span>
              </template>
            </el-table-column>
          </el-table>
        </div>
      </div>
    </div>

    <!-- 新生成 -->
    <el-dialog :title="textMap[newGeneration.dialogStatus]" :destroy-on-close="true" :visible.sync="newGeneration.dialogFormVisible" :close-on-click-modal="false" width="50%">
      <div class="newGeneration">
        <el-form ref="temp" :rules="newGeneration.rules" :model="newGeneration.temp" label-position="right" label-width="155px" style="width: 100%;margin:0 auto 50px">
          <el-row>
            <el-col :span="16">
              <el-form-item label="时间范围：" prop="inputDatetime">
                <el-date-picker v-model="newGeneration.temp.inputDatetime" class="inputDatetime filter-item" type="daterange" range-separator="至" start-placeholder="开始日期" end-placeholder="结束日期" style="width: 100%;" :clearable="false" />
              </el-form-item>
            </el-col>
          </el-row>
        </el-form>
        <div slot="footer" class="dialog-footer" style="bottom:10px">
          <el-button class="cancelClose" @click="newGeneration.dialogFormVisible = false;get_table_data()">取消</el-button>
          <el-button class="success" :disabled="isokDisable" @click="newGenerationData()">确认</el-button>
        </div>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { GetDataByName, GetDataByNames, ExecDataByConfig } from '@/api/common'
import { MessageBox } from 'element-ui'
import { parseTime } from '@/utils/index.js'
import Cookies from 'js-cookie'
export default {
  name: 'DailyExecutionPlan',
  data() {
    return {
      send_select_list: [
        // { name: 'getDictByName', offset: 0, pagecount: 0, params: ['牲畜父类'] }
      ],
      planTypeList: [{ lable: '撒料计划', value: '2' }, { lable: '预混计划', value: '4' }, { lable: '剩料计划', value: '3' }], // 计划类型
      printingTypeList: [{ lable: '所有', value: '0' }, { lable: '精料', value: '1' }, { lable: '铲车', value: '2' }], // 打印类型
      frequencyList: [], // 班次
      planningDimensionList: [{ lable: '发料顺序', value: '0' }, { lable: 'TMR', value: '1' }], // 发料顺序
      exportTypeList: [{ lable: '投料简打', value: '0' }, { lable: '投料简打', value: '1' }], // 导出类型
      // 班次
      maxTime: {
        getMaxTimesParm: {
          name: 'getSysoptEnable',
          page: 1,
          offset: 1,
          pagecount: 1,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid'),
            inforname: 'times'
          }
        }
      },
      table: {
        getdataListParm: {
          name: 'getDownloadedplanList',
          page: 1,
          offset: 1,
          pagecount: '',
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid'),
            barid: '',
            mydate: parseTime(new Date(), '{y}-{m}-{d}'),
            times: '',
            lpplantype: ''
          }
        },
        tableKey: 0,
        list: [],
        total: 0,
        listLoading: false
      },

      // 计划内容操作详情
      table2: {
        getdataListParm: {
          name: 'getDownloadplandtl1ListV2',
          page: 1,
          offset: 1,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid'),
            date: '',
            id: ''
          }
        },
        tableKey: 0,
        list: [],
        total: 0,
        listLoading: false
      },

      // 计划内容 舍栏详情
      table3: {
        getdataListParm: {
          name: 'getDownloadplandt2ListV2',
          page: 1,
          offset: 1,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid'),
            date: '',
            id: ''
          }
        },
        tableKey: 0,
        list: [],
        total: 0,
        listLoading: false
      },

      // 新生成
      newGeneration: {
        dialogFormVisible: false,
        dialogStatus: '',
        getdataListParm: {
          name: 'checkLLPIsDistribution',
          page: 1,
          offset: 1,
          pagecount: 1,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid')
          }
        },
        temp: {},
        rules: {
          inputDatetime: [{ type: 'array', required: true, message: '必填', trigger: 'blur' }]
        }
      },
      textMap: {
        newGeneration: '新生成'
      },
      isokDisable: false,
      requestParam: {},
      rowStyle: { maxHeight: 50 + 'px', height: 45 + 'px' },
      cellStyle: { padding: 0 + 'px' }
    }
  },

  created() {
    this.get_table_data()
    this.get_select_list()
    this.getIsDisplay()
  },
  mounted() {
    this.table.getdataListParm.parammaps.mydate = parseTime(new Date(), '{y}-{m}-{d}')
  },
  methods: {
    getIsDisplay() {
      GetDataByName(this.maxTime.getMaxTimesParm).then(response => {
        console.log(response.data.list[0].inforvalue)
        if (response.data.list[0].inforvalue == 1) {
          this.frequencyList = [{ id: '1', name: '第一班' }]
        } else if (response.data.list[0].inforvalue == 2) {
          this.frequencyList = [{ id: '1', name: '第一班' }, { id: '2', name: '第二班' }]
        } else if (response.data.list[0].inforvalue == 3) {
          this.frequencyList = [{ id: '1', name: '第一班' }, { id: '2', name: '第二班' }, { id: '3', name: '第三班' }]
        } else if (response.data.list[0].inforvalue == 4) {
          this.frequencyList = [{ id: '1', name: '第一班' }, { id: '2', name: '第二班' }, { id: '3', name: '第三班' }, { id: '4', name: '第四班' }]
        }
      })
    },
    get_select_list() {
      GetDataByNames(this.send_select_list).then(response => {
        // this.livestockTypeList = response.data.getDictByName.list
      })
    },
    // -------------------日执行计划-----------------------------
    handleBefore() {
      if (this.table.getdataListParm.parammaps.mydate !== '' && this.table.getdataListParm.parammaps.mydate !== null) {
        this.table.getdataListParm.parammaps.mydate = new Date(this.table.getdataListParm.parammaps.mydate)
        var start = new Date(this.table.getdataListParm.parammaps.mydate.setDate(this.table.getdataListParm.parammaps.mydate.getDate() - 1))
        // var start = this.table.getdataListParm.parammaps.mydate - 1
        this.table.getdataListParm.parammaps.mydate = parseTime(start, '{y}-{m}-{d}')
        // this.$forceUpdate()
        this.get_table_data()
      }
    },
    handleNext() {
      if (this.table.getdataListParm.parammaps.mydate !== '' && this.table.getdataListParm.parammaps.mydate !== null) {
        this.table.getdataListParm.parammaps.mydate = new Date(this.table.getdataListParm.parammaps.mydate)
        var stop = new Date(this.table.getdataListParm.parammaps.mydate.setDate(this.table.getdataListParm.parammaps.mydate.getDate() + 1))
        this.table.getdataListParm.parammaps.mydate = parseTime(stop, '{y}-{m}-{d}')
        this.get_table_data()
      }
    },
    get_table_data() {
      this.table.listLoading = true
      GetDataByName(this.table.getdataListParm).then(response => {
        console.log('table数据', response.data.list)
        if (response.data.list !== null) {
          this.table.list = response.data.list
          this.table.pageNum = response.data.pageNum
          this.table.pageSize = response.data.pageSize
          this.table.total = response.data.total
          this.table2.getdataListParm.parammaps.id = response.data.list[0].id
          this.table3.getdataListParm.parammaps.id = response.data.list[0].id
          this.table3.getdataListParm.parammaps.lpplantype = response.data.list[0].lpplantype
          this.get_table_data2()
          this.get_table_data3()
        } else {
          this.table.list = []
          this.table2.getdataListParm.parammaps.id = ''
          this.table3.getdataListParm.parammaps.id = ''
          this.get_table_data2()
          this.get_table_data3()
          this.table2.list = []
          this.table3.list = []
        }
        setTimeout(() => {
          this.table.listLoading = false
        }, 100)
      })
    },

    lpplantype: function (cellValue) {
      if (cellValue.lpplantype == 2) {
        return '撒料'
      } else if (cellValue.lpplantype == 4) {
        return '预混'
      } else if (cellValue.lpplantype == 3) {
        return '剩料'
      }
    },
    changeDate(val) {
      console.log('选择了日期', val)
      this.get_table_data()
      this.get_table_data2()
      this.get_table_data3()
    },
    changePlanType(val) {
      console.log('选择了计划类型', val)
      this.get_table_data()
      this.get_table_data2()
      this.get_table_data3()
    },
    changeFrequency(val) {
      console.log('选择了班次', val)
      this.get_table_data()
      this.get_table_data2()
      this.get_table_data3()
    },

    // 日执行计划行点击
    tableRowClick(row, column, event) {
      console.log(row, column, event)
      this.table2.getdataListParm.parammaps.date = this.table.getdataListParm.parammaps.mydate
      this.table2.getdataListParm.parammaps.id = row.id
      this.table3.getdataListParm.parammaps.date = this.table.getdataListParm.parammaps.mydate
      this.table3.getdataListParm.parammaps.id = row.id
      this.table3.getdataListParm.parammaps.lpplantype = row.lpplantype
      this.get_table_data2()
      this.get_table_data3()
    },

    // 计划内容操作详情
    get_table_data2() {
      this.table2.listLoading = true
      this.table2.getdataListParm.parammaps.date = this.table.getdataListParm.parammaps.mydate

      GetDataByName(this.table2.getdataListParm).then(response => {
        console.log('table数据', response.data.list)
        if (response.data.list !== null) {
          this.table2.list = response.data.list
          const arr = []
          var a = 0
          let b = this.table2.list[0].sort
          let c = 0
          for (let i = 0; i < this.table2.list.length; i++) {
            if (b !== parseInt(this.table2.list[i].sort)) {
              b = this.table2.list[i].sort
              arr.push({ 'sort': '小计', 'weight': a.toFixed(2) })
              a = 0
            }
            a = a + parseFloat(this.table2.list[i].weight)
            c = c + parseFloat(this.table2.list[i].weight)
            arr.push(this.table2.list[i])
          }
          arr.push({ 'sort': '小计', 'weight': a })
          arr.push({ 'sort': '总计', 'weight': c.toFixed(2) })
          this.table2.list = arr
          console.log(this.table2.list)
          this.table2.pageNum = response.data.pageNum
          this.table2.pageSize = response.data.pageSize
          this.table2.total = response.data.total
        } else {
          this.table2.list = []
        }
        setTimeout(() => {
          this.table2.listLoading = false
        }, 100)
      })
    },

    // 计划内容栏舍详情
    get_table_data3() {
      this.table3.listLoading = true
      this.table3.getdataListParm.parammaps.date = this.table.getdataListParm.parammaps.mydate

      GetDataByName(this.table3.getdataListParm).then(response => {
        console.log('table数据', response.data.list)
        if (response.data.list !== null) {
          this.table3.list = response.data.list
          this.table3.pageNum = response.data.pageNum
          this.table3.pageSize = response.data.pageSize
          this.table3.total = response.data.total
        } else {
          this.table3.list = []
        }
        setTimeout(() => {
          this.table3.listLoading = false
        }, 100)
      })
    },

    // 新生成
    form_add() {
      console.log('点击了新生成')
      this.newGeneration.temp = {}
      this.newGeneration.dialogStatus = 'newGeneration'
      this.newGeneration.dialogFormVisible = true
      GetDataByName(this.newGeneration.getdataListParm).then(response => {
        console.log('table数据', response.data.list)
        if (response.data.list !== null) {
          if (response.data.list[0].vmsg == '存在未分配') {
            this.$message({ type: 'warning', message: '撒料计划中存在未分配完栏舍，建议及时进行分配', duration: 2000 })
          }
        }
      })
    },
    newGenerationData() {
      console.log('点击了新生成保存', this.newGeneration.temp)
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 5000)
      this.$refs['temp'].validate(valid => {
        if (valid) {
          this.newGeneration.temp.startTime = parseTime(this.newGeneration.temp.inputDatetime[0], '{y}-{m}-{d}')
          this.newGeneration.temp.stopTime = parseTime(this.newGeneration.temp.inputDatetime[1], '{y}-{m}-{d}')
          this.requestParam = {}
          this.requestParam.common = { 'returnmap': '0' }
          this.requestParam.data = []
          this.requestParam.data[0] = {            'name': 'checkDLPIsStart', 'type': 'e', 'parammaps': {
              pastureid: Cookies.get('pastureid'),
              startTime: this.newGeneration.temp.startTime
            }          }
          this.requestParam.data[1] = {            'name': 'createdownloadedplan', 'type': 'e', 'parammaps': {
              pastureid: Cookies.get('pastureid'),
              startTime: this.newGeneration.temp.startTime,
              stopTime: this.newGeneration.temp.stopTime
            }          }
          ExecDataByConfig(this.requestParam).then(response => {
            console.log('新生成保存发送参数', this.requestParam)
            if (response.msg === 'fail') {
              this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
            } else {
              this.$notify({ title: '', message: '保存成功', type: 'success', duration: 2000 })
              this.newGeneration.dialogFormVisible = false
              this.get_table_data()
            }
          })
        }
      })
    },

    // 配方模板
    handleRecipeemplate() {
      console.log('点击了配方模板,页面待画')
    },
    handleShedFormula() {
      console.log('点击了栏舍配方,页面待画')
    },
    handlePremixedPlan() {
      console.log('点击了预混计划,页面待画')
    },
    handleMaterialPlan() {
      console.log('点击了撒料计划,页面待画')
    },
    handleHistoryRecord() {
      console.log('点击了历史记录,页面待画')
    },
    form_export() {
      console.log('点击了导出')
    }

  }
}
</script>
<style lang="scss" scoped>
.operation {
  margin-bottom: 10px;
}
.search {
  margin-top: 10px;
}
.table {
  margin-top: 10px;
}

.template {
  background: #fff;
  position: relative;
  .recipeTemplate {
    width: 72px;
    height: 70px;
    position: absolute;
    background: url(../../../assets/images/bg3.jpg) no-repeat;
    right: 0;
    top: 0;
    margin: 0;
  }
}

.table2 {
  float: left;
  width: 49%;
  margin-right: 1%;
  background: red;
  background: #fff;
  position: relative;
  .contentOperation {
    width: 72px;
    height: 70px;
    position: absolute;
    background: url(../../../assets/images/bg4.jpg) no-repeat;
    right: 0;
    top: 0;
    margin: 0;
  }
  .content-table {
    margin-top: 70px;
  }
}
.table3 {
  float: left;
  width: 49%;
  background: #fff;
  position: relative;
  .stallRetails {
    width: 72px;
    height: 70px;
    position: absolute;
    background: url(../../../assets/images/bg5.jpg) no-repeat;
    right: 0;
    top: 0;
    margin: 0;
    // p{
    //   font-size: 12px;
    //   transform:rotate(45deg);
    //   -ms-transform:rotate(45deg); /* Internet Explorer 9*/
    //   -moz-transform:rotate(45deg); /* Firefox */
    //   -webkit-transform:rotate(45deg); /* Safari 和 Chrome */
    //   -o-transform:rotate(45deg); /* Opera */
    //   filter: progid:DXImageTransform.Microsoft.BasicImage(rotation=1);
    // }
  }
  .content-table {
    margin-top: 70px;
  }
}
</style>
